#include <bits/stdc++.h>
using namespace std;
#define IOS ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define ll long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

vector<ll> dist(2010, -1);
vector<bool> u(2010, false);
queue<ll> q;

ll bfs(ll n, ll v, vector<vector<ll>> &g, ll t) {
    dist.resize(n);
    q.push(v);
    dist[v] = 0;
    while (!q.empty()) {
        v = q.front();
        q.pop();
        for (ll to : g[v]) {
            if (!u[to]) {
                u[to] = true;
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
    return dist[t];
}
// g - список смежности, n - размер, v - начало, t - конец

int main() {
    IOS
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    ll x, y;
    for (ll i = 0; i < m; i++) {
        cin >> x >> y;
        g[x - 1].push_back(y - 1);
        g[y - 1].push_back(x - 1);
    }
    vector<pair<ll, ll>> v(k);
    vector<bool> sec(n, false);
    for (ll i = 0; i < k; i++) {
        cin >> v[i].first >> v[i].second;
        sec[v[i].first - 1] = true;
        v[i].first--;
    }
    for (ll i = 0; i < k; i++) {
        for (ll j = 0; j < n; j++) {
            if (v[i].first != j && !sec[j]) {
                if (bfs(n, v[i].first, g, j) != -1 && bfs(n, v[i].first, g, j) <= v[i].second) {
                    sec[j] = true;
                }
            }
        }
    }
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        if (sec[i]) {
            ans++;
        }
    }
    cout << ans << '\n';
    for (ll i = 0; i < n; i++) {
        if (sec[i]) {
            cout << i + 1 << ' ';
        }
    }
}
